import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class SButton extends JButton
{
	private int tool;
	SToolBar toolbar;
	boolean subMenu;
	String description;
	String url;

	public SButton (String url, String description, int tool, boolean subMenu, SToolBar toolbar)
	{
		//Creates a new image button from the given url
		super(new ImageIcon(url));
		
		this.url = url;

		this.description = description;
		this.tool = tool;
		this.toolbar = toolbar;

		this.subMenu = subMenu;
		//setLocation (position[0],position[1]);
		this.setPreferredSize (new Dimension(23,23));
		this.setSize(23,23);

		//Sets a 1px border round the button
		super.setBorder(BorderFactory.createMatteBorder(1,1,1,1, new Color(0x666666)));

		//Captures button click
		addActionListener (new ActionListener ()
		{
			public void actionPerformed (ActionEvent ae)
			{
				handleMouse(true);
			}
		});

		addMouseListener (new MouseAdapter ()
		{
			public void mouseEntered(MouseEvent me)
			{
				handleMouse(false);
			}
		});
	}
	
	/*
	 * Changes the background color of the button
	 * @param state 0 or 1 depending on whether or not the button is active
	 */
	public void changeState(int state)
	{
		if (state==0) setBackground(new Color (0xCCCCCC));
		if (state==1) setBackground(new Color (0xFFFFFF));
	}
	
	public void clickify() {
		handleMouse(true);
	}

	//Function to deal with button clicking
	private void handleMouse(boolean clicked)
	{
		if(tool==6&&subMenu)
		{
			int whereisdot = url.indexOf(".");
			String identity = url.substring(whereisdot-1,whereisdot);
			toolbar.setActive(tool,subMenu,clicked,description,identity);
		}
		else
		{
			toolbar.setActive(tool,subMenu,clicked,description);
		}
	}
}