/**
 * This is a constraint that measures the collinearity of three points.
 *
 * @author David Stark
 * @version 1.0
*/
public class SCCollinear extends SConstraint{

/**
 * The constructor.
 *
 * @param refs the shapes this constraint should refer to
*/
public SCCollinear(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	super(owner, refs, 3, 0, 0, 0, additional_points);
}

/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	return java.lang.Math.abs(values[0]*(values[3] - values[5]) + values[2]*(values[5]-values[1]) + values[4]*(values[1]-values[3])) / 1000; //x1*(y2 - y3) + x2*(y3-y1) + x3*(y1-y2)
}

/**
 * @returns the symbol representing this constraint
 */
public static String getSymbol()
{ return "C";
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {3,0,0,0};
	return (reqShapes);
}

/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "C";
	}

/**
 * @returns a description of the constraint
 */
public static String getDescription()
{
	return "Click on three points to make them collinear " +
	       "(arrange them so that they lie on one straight line)";
}

   
}
