import java.util.ArrayList;
import java.util.Collection;

/**
 * This is a constraint that makes a 2-point object stand erect.
 * Really exactly the same as SCSameX.
 *
 * @author David Stark
 * @version 1.0
*/
public class SCErect extends SConstraint{

/**
 * The constructor.
 *
 * @param refs the shapes this constraint should refer to
*/
public SCErect(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	//requires a single 2-point object
	super(owner, refs, 0, 1, 0, 0, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {0,1,0,0};
	return (reqShapes);
}

/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	return java.lang.Math.abs(values[0] - values[2]);
}

/**
 * Returns the collection of variables this constraint applies to.
 *
 * @returns the collection of variables this constraint applies to
*/
public ArrayList myVariables() {
	ArrayList ret = new ArrayList();

	ret.add(allVariables[0]);
	ret.add(allVariables[2]);
	
	return ret;
}

	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "V";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "V";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
	    return "Click on a line to make it vertical, or on a constraint with two attachers to make their attachers line up vertically.";
	}
	
}
