/**
 * This constraint demands that the scaling factor of a given instance be x times normal.
*/

public class SCInstanceIsOriginalSize extends SConstraint{

/**
 * The constructor.
 * @param refs contains the scaling factor of the instance
*/
public SCInstanceIsOriginalSize(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	super(owner, refs, 0, 0, 0, 1, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {0,0,0,1};
	return (reqShapes);
}

/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	return java.lang.Math.abs(values[0] - 256);
}

	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "O";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "O";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
		return "Select an instance of an object which you would like to remain the same size as the "
				+ "master object which is saved to the library.";
	}	
}