import java.util.Collection;
import java.util.ArrayList;

/**
 * This constraint demands that the scaling factor of a given instance be x times normal.
*/

public class SCInstanceIsXTimesSmallerThanOriginal extends SConstraint{

/**
 * The constructor.
 * @param refs contains the scaling factor of the instance first, and then the SVariable that is the
 * amount by which the scaling factor should be multiplied
*/
public SCInstanceIsXTimesSmallerThanOriginal(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	super(owner, refs, 0, 0, 0, 2, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {0,0,0,2};
	return (reqShapes);
}

/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	return Math.abs(256 / values[1] - values[0]);
}

/**
 * This is over-ridden from the main class because the multiplier variable is not bound by this constraint.
 * It is for reference only.
 * @returns the collection of variables this constraint applies to
*/
public ArrayList myVariables() {
	ArrayList ret = new ArrayList();
	ret.add(allVariables[0]);
	return ret;
}


	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "lct";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "t";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
		return "Select an instance and a number label. This constraint makes "+
		       "the instance as many times smaller than the original as the number indicates.";
	}

}
