import java.util.ArrayList;
import java.util.Collection;

/**
 * This is a constraint that makes a 2-point object lie on its side.
 * Really exactly the same as SCSameY.
 *
 * @author David Stark
 * @version 1.0
*/
public class SCOnItsSide extends SConstraint{

/**
 * The constructor.
 *
 * @param refs the shapes this constraint should refer to
*/
public SCOnItsSide(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	//requires a single 2-point object
	super(owner, refs, 0, 1, 0, 0, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {0,1,0,0};
	return (reqShapes);
}

/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	return java.lang.Math.abs(values[1] - values[3]);
}

/**
 * Returns the collection of variables this constraint applies to.
 *
 * @returns the collection of variables this constraint applies to
*/
public ArrayList myVariables() {
	ArrayList ret = new ArrayList();

	ret.add(allVariables[1]);
	ret.add(allVariables[3]);
	
	return ret;
}

	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "H";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "H";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
		return "Click on a line to make it horizontal, or on an instance with two attachers to make its attachers be at the same height.";
	}
	
}
