/**
 * Demands that two lines be perpendicular.
*/
public class SCPerpendicular extends SConstraint{

/**
 * Constructor.
*/
public SCPerpendicular(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	super(owner, refs, 0, 2, 0, 0, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {0,2,0,0};
	return (reqShapes);
}

/**
 * Calculates the error for the given values.
*/
public int calcError(int values[]) {
	return java.lang.Math.abs( (values[2] - values[0]) * (values[6] - values[4]) + (values[3] - values[1]) * (values[7] - values[5]) ) / 1000;
}

	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "lcp";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "p";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
		return "Select two lines, and the constraint will make them perpendicular.";
	}
	
}