import java.util.ArrayList;
import java.util.Collection;

/**
 * This is a "same height" constraint which makes two points be at the same y-coordinate.
 *
 * @author David Stark
 * @version 3.0
*/
public class SCSameY extends SConstraint {

/**
 * The constructor.
 *
 * @param refs the shapes this constraint should refer to
*/
public SCSameY(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	super(owner, refs, 2, 0, 0, 0, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {2,0,0,0};
	return (reqShapes);
}

/**
 * Returns the collection of variables this constraint applies to.
 *
 * @returns the collection of variables this constraint applies to
*/
public ArrayList myVariables() {
	ArrayList ret = new ArrayList();

	ret.add(allVariables[1]);
	ret.add(allVariables[3]);
	
	return ret;
}


/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	return java.lang.Math.abs(values[1] - values[3]);
}
	

	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "Y";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "Y";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
		return "Select two points and the constraint makes their y-coordinate the same.";
	}
	
}
