import java.util.HashSet;
import java.util.Iterator;
import java.io.Serializable;


/**
 * This class serves the single purpose of being able to reset the values of a number of variables.
 * It is used for undoing constraint satisfaction.
 *
 * @author David Stark
 * @version 1.0
*/
public class SCSolverUndo implements Serializable {

private HashSet myVars;

/**
 * The constructor. It simply receives the set of variables that may later have to be reset, and calls cacheValue() on them.
*/
public SCSolverUndo(HashSet myVars) {
	this.myVars = myVars;
	Iterator iter = myVars.iterator();
	while (iter.hasNext()) {
		((SVariable) iter.next()).cacheValue();
	}
}

/**
 * The undo method. Resets all variables to their cached values.
*/
public void undo() {
	Iterator iter = myVars.iterator();
	while (iter.hasNext()) {
		((SVariable) iter.next()).resetFromCache();
	}
}

}
