import java.util.Collection;
import java.util.ArrayList;
import java.lang.Math;

/**
 * Sets the value of a given variable to the  distance of 2 points.
 *
 * @author David Stark
 * @version 1.0
*/
public class SCVarIsDistance extends SConstraint{

/**
 * The constructor.
 *
 * @param refs the shapes this constraint should refer to
*/
public SCVarIsDistance(SFile owner, java.util.ArrayList refs, java.util.ArrayList additional_points) throws SConstraintCouldNotBeCreatedException {
	super(owner, refs, 2, 0, 0, 1, additional_points);
}

/**
 * @returns an integer array representing the number of points, lines and arcs required
 */
public static int[] getRequired()
{
	int[] reqShapes = {2,0,0,1};
	return (reqShapes);
}

/**
 * The function to calculate the error of this constraint for the given variables.
*/
public int calcError(int values[]) {
	int dx = values[0] - values[2];
	int dy = values[1] - values[3];
	return Math.abs(values[4] - ((int) Math.abs( Math.sqrt((double) ((dx*dx + dy*dy))))));
}

/**
 * This is over-ridden from the main class because the distance variable is not bound by this constraint.
 * It is for reference only.
 * @returns the collection of variables this constraint applies to
*/
public ArrayList myVariables() {
	ArrayList ret = new ArrayList();

	ret.add(allVariables[4]);
	
	return ret;
}

	/**
 	* @returns the symbol representing this constraint
 	*/
	public static String getSymbol()
	{ return "lcd";
	}
	
	/**
 	* @returns the symbol representing this constraint
 	*/
	public String getSymbolDyn()
	{ return "d";
	}

	/**
 	* @returns a description of the constraint
 	*/
	public static String getDescription()
	{
		return "Select a number label and two points and the system will set the value of the number label "
		     + "equal to the distance between these two points.";
	}

	
}
