/**
 * This exception is thrown if a constraint could not be created with the given input data.
 *
 * @author Tom Craig, David Stark
 * @version 1.0
*/

public class SConstraintCouldNotBeCreatedException extends java.lang.Exception {

/**
 * The error message stored.
*/
private String message;

/**
 * The constructor.
 * Note: could not make constructor abstract.
 * @param message An explanation as to why the constraint could not be created.
*/
public SConstraintCouldNotBeCreatedException(String message) {
    super(message);
	this.message = message;
}

/**
 * This can be used to display a semi-helpful error message.
 * @returns an error message
*/
public String toString() {
	return "Constraint could not be created: " + message;
}

}
