import java.awt.Graphics;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.awt.Font;
import java.awt.FontMetrics;

/*
 * Created on 23-Feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Matthew Brown
 */

public class SNumber extends SShape implements Cloneable, Serializable
{

	/**
	 * What the label says.
	 */
	
	private SVariable numberVal;
	
    /**
     * Constructor.
     */
    public SNumber(SPoint topLeft, int newValue, SFile owner)
    {
        super(topLeft.getLocation() /* shape's handle location is its top left */, owner);
        
        this.topLeft = topLeft;
        numberVal = new SVariable(newValue);
    }
    
    /**
	 * Stores the page co-ordinates of the top left of the instance.
	 */
	public SPoint topLeft = null;
	
    /**
     * @return Returns the text.
     */
    public SVariable getValue()
    {
        return numberVal;
    }
    
    public int getIntValue()
    {
        return numberVal.getValue();
    }
    /**
     * @param value The value to set.
     */
    public void setValue(int newValue)
    {
    	numberVal.setValue(newValue);
    }
	/**
	 * Get the top left.
	 */
	public SPoint getTopLeft()
	{
	    return topLeft;
	}

    /**
     * @see SShape#getPoints()
     */
    public Collection getPoints()
    {
        ArrayList pts = new ArrayList();
        pts.add(topLeft);
        return pts;
    }

    /**
     * @see SShape#getBoundingBox(SIntPair, SIntPair)
     */
    public void getBoundingBox(SIntPair topLeft, SIntPair bottomRight)
    {
		Font f = SDrawSketch.FONT_USED_FOR_TEXT;
		g.setFont(f);
		String s = "" + numberVal.getValue();
		FontMetrics fm   = g.getFontMetrics(f);
		java.awt.geom.Rectangle2D rect = fm.getStringBounds(s, g);
		int textHeight = (int)(rect.getHeight())*SDrawSketch.getZoom();
		int textWidth  = (int)(rect.getWidth())*SDrawSketch.getZoom();
		
		topLeft.x = this.topLeft.getX().getValue()+5;
		topLeft.y = this.topLeft.getY().getValue()+5;
		bottomRight.x = this.topLeft.getX().getValue() + textWidth+15;
		bottomRight.y = this.topLeft.getY().getValue() + textHeight+5;
  }
  
	/**
	 * Returns the distance of the given position from this number.
	*/
	public double minDistanceFromCoords(SIntPair position) {
		SIntPair topLeft = new SIntPair(0,0);
		SIntPair bottomRight = new SIntPair(0,0);
		double distance = 0;
		getBoundingBox(topLeft, bottomRight);
		if((position.x > topLeft.x)&&(position.y > topLeft.y)&&(position.x < bottomRight.x)&&(position.y < bottomRight.y))
		{
			return distance;
		}
		else
		{
			double minX = Math.min(Math.abs(topLeft.x - position.x), Math.abs(bottomRight.x - position.x));
			double minY = Math.min(Math.abs(topLeft.y - position.y), Math.abs(bottomRight.y - position.y));
			distance = Math.min(minX,minY);
		}
		return distance;
	}

    /**
     * @see SShape#getCoordinateRange()
     */
    public Collection getCoordinateRange()
    {
        // TODO This coordinate range is pathetic! At the moment the user has to move very
        // near the top left to select. Do a better one!
        
        ArrayList coordRange = new ArrayList();
        coordRange.add(new SIntPair(topLeft.getX().value(), topLeft.getY().value()));
        return coordRange;
    }

	/**
    * @returns object reference for cloned object
    */
    public Object clone()
    {
    	Object cln = null;
   		cln = super.clone();
    	
    	return cln;
    }
    

    /**
     * Nasty hack!
     */
    public static Graphics g;

}
