import java.awt.*;
import java.awt.print.*;

/*****************************************************************************************
*  This class is used to print out the sketch that is currently displayed on
the screen. *
*  This is a generic class in that it contains just one static method that can
be used   *
*  to print any graphics object. The quality of the Graphics object that is
printed is   *
*  increased by casting the Graphics object to a Graphics2D object first.
*
*****************************************************************************************/
public class SPrintSketch implements Printable {

/*****************************************************************************************
* This method implements the print method defined in the Printable interface.
It takes
* a graphics object, casts it to a Graphics2D object for better printer output
and then
* prints the image
*
* @param  g The graphics object which is to be printed
* @param pf The format of the page to which the graphic will be printed
* @param pageIndex
* @return        integer specifying whether or not the page exits
*****************************************************************************************/
public int print(Graphics g, PageFormat pf, int pageIndex) {

         if(pageIndex > 0) return Printable.NO_SUCH_PAGE;
         Graphics2D gprint = (Graphics2D) g;
         gprint.translate(pf.getImageableX(), pf.getImageableY());
         //drawGraphics(gprint, pf);
         return Printable.PAGE_EXISTS;
}

/*****************************************************************************************
* This method acts as the interface to this class. The calling class passes the
graphics
* object that requires printing, and then retrieves information about the
current
* printer page format and then calls the print method of this class. Catches
the
* PrinterException exception and returns -1 as a return value to signify a
printing
* error
*
* @param  g The graphics object which is to be printed
* @return        integer: 0 if printing successful, -1 if printing fails.
*****************************************************************************************/
public static int PrintS(Graphics g)
{
  PrinterJob pj = PrinterJob.getPrinterJob(); // Get current printer info
  PageFormat pf = pj.defaultPage();          // Load user's default page setup
  //pj.setPrintable(new BasicPrint(), pf);

 // try
 // {
   // pjob.print();
 // }

  //catch (PrinterException e)
  //{
  // The user may not have a printer installed so return a negative value
  // to the caller to show that an error has occured. The caller can relay this
  // information to the user
 // return -1;
 // }

return 0; // Non erroneous return
}


}
